<?php
/*
 * Battle was developed for SMF forums c/o SA, nend & Chen Zhen
 * Copyright 2022 ~ Chen Zhen @ web-develop.ca
 * Revamped and supported by Chen Zhen
 * This software package is distributed under the terms of its Creative Commons - Attribution No Derivatives License (by-nd) 3.0
 * License: https://creativecommons.org/licenses/by-nd/3.0/
 * Support thread: https://web-develop.ca/index.php?board=15.0
 */

if (!defined('SMF'))
	require '../SSI.php';

global $modSettings;

$smfVersion = version_compare((!empty($modSettings['smfVersion']) ? mb_substr($modSettings['smfVersion'], 0, 3) : '2.0'), '2.1', '<') ? 'v2.0' : 'v2.1';


if ($smfVersion == 'v2.0') {
	remove_integration_function('integrate_pre_include', '$sourcedir/SMF2-0_BattleHooks.php');
}
else {
	remove_integration_function('integrate_load_custom_profile_fields', 'battle_custom_profile');
    remove_integration_function('integrate_pre_include', '$sourcedir/SMF2-1_BattleHooks.php');
	remove_integration_function('integrate_load_member_data', 'battle_load_member_data');
	remove_integration_function('integrate_prepare_display_context', 'battle_display_context');
	remove_integration_function('integrate_prepare_pm_context', 'battle_display_context');
}
remove_integration_function('integrate_actions', 'battle_actions');
remove_integration_function('integrate_load_permissions', 'battle_load_permissions');
remove_integration_function('integrate_menu_buttons', 'battle_menu_buttons');
remove_integration_function('integrate_admin_areas', 'battle_admin_areas');
remove_integration_function('integrate_pre_load', 'battle_language');
remove_integration_function('integrate_pre_load', 'battle_files');
remove_integration_function('integrate_register', 'battle_user_info');
remove_integration_function('integrate_user_info', 'battle_user_settings');
remove_integration_function('integrate_member_context', 'battle_member_context');

?>